/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Options;


import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.util.HashMap;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.sos.JSHelper.Options.JSOptionIndexedItem;
import com.sos.JSHelper.Options.JSOptionsClass;

/**
* \class JSOptionIndexedItemTest 
* 
* \brief JSOptionIndexedItemTest - 
* 
* \details
*
* \section JSOptionIndexedItemTest.java_intro_sec Introduction
*
* \section JSOptionIndexedItemTest.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author EQALS
* \version 19.10.2009
* \see reference
*
* Created on 19.10.2009 14:40:12
 */

public class JSOptionIndexedItemTest {

	@SuppressWarnings("unused")
	private final String	conClassName	= "JSOptionIndexedItemTest";
	
	private HashMap<String, String>	settings		= null;
	private JSOptionsClass	 		objOptions		= null;
	
	public JSOptionIndexedItemTest() {
		//
	}

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		settings = new HashMap<String, String>();
		objOptions = new JSOptionsClass(settings);
	}

	@After
	public void tearDown() throws Exception {
	}
	
	@Test
	public void testAddItem() throws Exception {
		
		JSOptionIndexedItem objII = new JSOptionIndexedItem(objOptions, 
				"dummyKey", 
				"Descr", 
				"", 
				"", false);
		
		assertTrue( "Keine Indexed Options vorhanden", objII.IsEmpty());
		assertEquals( "Anzahl Indexed Options = 0", 0, objII.value().length);
		
		objII.AddItem("Item 1");		
		assertFalse( "Indexed Options vorhanden", objII.IsEmpty());
		assertEquals( "Anzahl Indexed Options = 1", 1, objII.value().length);

		objII.AddItem("Item 2a;Item 2b;");		
		assertEquals( "Anzahl Indexed Options = 2", 2, objII.value().length);

		assertEquals( "Indexed gefunden", "Item 1", objII.value()[0]);
		assertEquals( "Indexed gefunden", "Item 2a;Item 2b;", objII.value()[1]);

		
	}
	
}
