/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.io.Files;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

/**
* \class JSFileTest 
* 
* \brief JSFileTest - 
* 
* \details
*
* \section JSFileTest.java_intro_sec Introduction
*
* \section JSFileTest.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author EQALS
* \version 14.09.2009
* \see reference
*
* Created on 14.09.2009 09:30:29
 */

public class JSFileTest {

	private final String	conClassName	= "JSFileTest";
	private final 		String strRec = "Eine Zeile zum Test ...";
	private static String strTestFileName = "c:/temp/test.txt";
	
	public JSFileTest() {
		//
	}

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		JSFile fleFile = new JSFile(strTestFileName);
		fleFile.delete();
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	//	@Test
	public void testCopy() throws Exception {
		JSFile fleFile = new JSFile("L:/TestData/data/invcon/reference-stocks-1546.xml");
		JSFile fleTarget = new JSFile("L:/TestData/data/invcon/reference-stocks-1546b.xml");
		fleFile.copy("L:/TestData/data/invcon/reference-stocks-1546b.xml");
		fleTarget.delete();

		// Anderer Konstruktor
		fleFile = new JSFile("L:/TestData/data/invcon/", "reference-stocks-1546.xml");
		fleFile.copy("L:/TestData/data/invcon/reference-stocks-1546b.xml");
		fleTarget.delete();
	}

	@Test
	public void testLock() throws Exception {
		JSFile fleFile = new JSFile(strTestFileName);
		fleFile.doLock();
		assertTrue("Erwartet wird ein true, weil File gesperrt ... ", fleFile.isLocked());

		fleFile.WriteLine(strRec);

		fleFile.close();
		assertFalse("Erwartet wird ein false, weil File nicht mehr gesperrt ... ", fleFile.isLocked());
	}

	@Test
	public void testExclusive() throws Exception {
		JSFile fleFile = new JSFile("c:/temp/test-exclusive.txt");
		fleFile.setExclusive(true);
		fleFile.WriteLine("Die Basis ist das Fundament der Grundlage");
		assertTrue("Erwartet wird ein true, weil File exclusive ... ", fleFile.isExclusive());

		fleFile.close();
		assertFalse("Erwartet wird ein false, weil File nicht mehr exclusive ... ", fleFile.isExclusive());
		fleFile.delete();
	}

	@Test
	public void doDelete() {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::doDelete";
		
		JSFile fleFile = new JSFile(strTestFileName);
		 
		fleFile.delete();
		assertFalse("Erwartet wird ein false, weil File nicht mehr da ... ", fleFile.exists());

	} // private void doDelete

	@Test
	public void doWrite() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::doWrite";
		
		JSFile fleFile = new JSFile(strTestFileName);
		fleFile.doLock();
		for (int i = 0; i < 1; i++) {
			fleFile.WriteLine(strRec);			
		}
		fleFile.close();
		
		assertEquals("Satz vergleich", strRec  + System.getProperty("line.separator"), fleFile.File2String());
		fleFile.close();
	} // private void doWrite
	
	@Test
	public void getLine() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::getLine";
		
		
		JSFile fleFile = new JSFile(strTestFileName);
		fleFile.doLock();

		assertEquals("Satz vergleich", strRec, fleFile.GetLine().toString());
		fleFile.close();
		
	} // private void getLine
	
	@Test
	public void doRead() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::doRead";
		
		JSFile fleFile = new JSFile(strTestFileName);
		fleFile.doLock();

		assertEquals("Satz vergleich", strRec  + System.getProperty("line.separator"), fleFile.File2String());
		fleFile.close();
		
	} // private void doRead
	
	@Test
	public void MassRandom() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::MassRandom";
		
		JSFile fleFile = new JSFile(strTestFileName);
		fleFile.doLock();
		for (int i = 0; i < 10000; i++) {
			fleFile.WriteLine(strRec);			
		}
		fleFile.close();
		fleFile.delete();
		assertEquals("Dummy", "a", "a");
	} // private void MassRandom

	@Test
	public void MassSequential() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::MassSequential";
		
		JSFile fleFile = new JSFile(strTestFileName);
		for (int i = 0; i < 10000; i++) {
			fleFile.WriteLine(strRec);			
		}
		fleFile.close();
		
		assertEquals("Dummy", "a", "a");
	} // private void MassSequential

	@Test
	public void CreateBackupTest() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::CreateBackupTest";
		
		JSFile fleFile = new JSFile(strTestFileName);
		String strNewFileName = fleFile.CreateBackup();
		fleFile.close();
		JSFile fleBackUp = new JSFile(strNewFileName);
		assertTrue("Datei existiert", fleBackUp.exists());
		fleBackUp.delete();
	} // private void CreateBackupTest

	@Test
	public void CreateBackupTest2() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::CreateBackupTest2";
		
		JSFile fleFile = new JSFile(strTestFileName);
		String strNewFileName = fleFile.CreateBackup(".willi");
		fleFile.close();
		JSFile fleBackUp = new JSFile(strNewFileName);
		assertTrue("Datei existiert", fleBackUp.exists());
		fleBackUp.delete();
	} // private void CreateBackupTest2

	@Test
	public void CreateBackupTest3() throws Exception {
		
		@SuppressWarnings("unused")
		final String	conMethodName	= conClassName + "::CreateBackupTest3";
		
		JSFile fleFile = new JSFile(strTestFileName);
		fleFile.BackupFolderName.Value(System.getProperty("java.io.tmpdir"));
		String strNewFileName = fleFile.CreateBackup(".willi");
		fleFile.close();
		JSFile fleBackUp = new JSFile(strNewFileName);
		assertTrue("Datei existiert", fleBackUp.exists());
		fleBackUp.delete();
	} // private void CreateBackupTest3

}
