/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Exceptions;
/* ---------------------------------------------------------------------------
 APL/Software GmbH - Berlin
##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
2007-11-26, kb@sos-berlin.com (sgx2343)
-------------------------------------------------------------------------------
<docu type="smcw" version="1.0">
<project>sos.dataswitch</project>
<name>JSExceptionMandatoryOptionMissing.java</name>
<title>Exception used if a mandatory Option is not specified
</title>
<description>
<para>
Exception used if a mandatory Option is not specified
</para>
</description>
<params>
</params>
<keywords>
	<keyword>Exception</keyword>
	<keyword>Option</keyword>
</keywords>
<categories>
<category>Exception</category>
</categories>
<date>2007-11-26</date>
<copyright> 2006 by Klaus D. Buettner</copyright>
<author>kb@sos-berlin.com</author>
<changes>
 <change who='sgx2343' when='2007-11-26' id='created'>
   <what>
   <para>
   created
   </para>
   </what>
 </change>
</changes>
</docu>
---------------------------------------------------------------------------- */
/*!
 * @class JSExceptionMandatoryOptionMissing
 * @brief Exception used if a mandatory Option is not specified
 * 
 * ... more details regarding this class...
 * 
 * @author kb@sos-berlin.com
 */
public class JSExceptionMandatoryOptionMissing  extends JobSchedulerException {
	@SuppressWarnings("unused")
	private static final String	conClassName	= "JSExceptionMandatoryOptionMissing";	
	private static final long serialVersionUID = 1L;
    /*!
     * Construtor with message.
     *
     * @param pstrMessage the message-text of the exception
     */
    public JSExceptionMandatoryOptionMissing(String pstrMessage) {
        super(pstrMessage);
        this.Message(pstrMessage);
        this.Status(JobSchedulerException.PENDING);
        this.Category(CategoryOptions);
        this.Typ(TypeOptionMissing); 
        this.eMailSubject("Mandatory Option missing.");        
    }
    
	public JSExceptionMandatoryOptionMissing ()
	{
		this ("exception 'JSExceptionMandatoryOptionMissing' raised ...");
	} // public JSExceptionMandatoryOptionMissing
	
	public String ExceptionText () {
		String strT = null;
		strT = super.ExceptionText();
		return strT;
		}

} // public class JSExceptionMandatoryOptionMissing
