/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Options;

import com.sos.JSHelper.Annotations.JSOptionDefinition;

/**
* \class JSOptionFolderName
*
* \brief JSOptionFolderName -
*
* \details
*
* \section JSOptionFolderName.java_intro_sec Introduction
*
* \section JSOptionFolderName.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* \version 14.06.2009
* \see reference
*
* Created on 14.06.2009 16:52:26
 */

/**
 * @author KB
 *
 */
public class JSOptionFolderName extends SOSOptionElement {

	private final String	conClassName	= "JSOptionFolderName";

	/**
	* \brief CreateFolder - Option: Folder anlegen, wenn noch nicht vorhanden
	*
	* \details
	*
	*/
	@JSOptionDefinition(name = "CreateFolder", value = "true", description = "Folder anlegen, wenn noch nicht vorhanden", key = "CreateFolder", type = "JSOptionBoolean", mandatory = false)
	public SOSOptionBoolean	CreateFolder	= new SOSOptionBoolean(this.objParentClass, // Verweis auf die SOSOptionClass-Instanz
													this.conClassName + ".CreateFolder", // Schlssel, i.d.r. identisch mit dem Namen der Option
													"Folder anlegen, wenn noch nicht vorhanden", // Kurzbeschreibung
													"true", // Wert
													"true", // defaultwert
													false // Option muss einen Wert haben
											);

	/**
	 * \brief JSOptionFolderName
	 *
	 * \details
	 *
	 * @param pobjParent
	 * @param pstrKey
	 * @param pstrDescription
	 * @param pstrValue
	 * @param pstrDefaultValue
	 * @param pflgIsMandatory
	 */
	public JSOptionFolderName(final JSOptionsClass pobjParent, final String pstrKey, final String pstrDescription, final String pstrValue,
			final String pstrDefaultValue, final boolean pflgIsMandatory) {
		super(pobjParent, pstrKey, pstrDescription, pstrValue, pstrDefaultValue, pflgIsMandatory);
		// TODO Auto-generated constructor stub
	}

	/**
	 *
	 * \brief Value - setzt die Property UserDir
	 *
	 * \details
	 *
	 * \return
	 *
	 * @param pstrFolderName
	 * @throws Exception
	 */
	@Override
	public void Value(final String pstrFolderName) {

		@SuppressWarnings("unused")
		final String conMethodName = this.conClassName + "::Value";
//		if (this.objParentClass != null) {
//			// prfen, ob es den Folder gibt ...
//			pstrFolderName = this.objParentClass.CheckFolder(pstrFolderName, conMethodName, this.CreateFolder.flgValue);
//		}
		super.Value(pstrFolderName);
//		System.out.println("pstrFolderName = " + super.Value());

	} // public void Value

	/**
	 * \brief Value - Wert der Option liefern
	 *
	 * \details
	 *
	 * @param pstrValue
	 * @return
	 * @throws Exception
	 */
	@Override
	public String Value() throws Exception {
		final String conMethodName = this.conClassName + "::Value";
		if (this.strValue == null) {
			this.strValue = "";
		}
		else {
			if (this.objParentClass != null) {
				// prfen, ob es den Folder gibt ...
				this.strValue = this.objParentClass.CheckFolder(this.strValue, conMethodName, this.CreateFolder.flgValue);
			}
		}

		return this.strValue;
	}

}
