/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: Spooler.java 3699 2005-06-09 14:05:10Z jz $

package sos.spooler;

/** 
 *
 * @author Joacim Zschimmer, Zschimmer GmbH
 * @version $Revision: 3699 $
 */

public class Xslt_stylesheet  extends Idispatch
{
    private                 Xslt_stylesheet     ( long idispatch )                  { super(idispatch); }

    /*+ Sollte nach dem Gebrauch gerufen werden. */
    public void             close               ()                                  { com_call( "close" ); }
    
    /*+ L�dt das Stylesheet aus einer Datei. */
    public Xslt_stylesheet  load_file           ( java.io.File file )               { return load_file( file.toString() ); }
    
    /*+ L�dt das Stylesheet aus einer Datei. */
    public Xslt_stylesheet  load_file           ( String path )                     { return (Xslt_stylesheet)com_call( "load_file", path ); }
    
    /*+ L�dt das Stylesheet aus dem XML-String. */
    public Xslt_stylesheet  load_xml            ( String xml )                      { return (Xslt_stylesheet)com_call( "load_xml", xml ); }

    /*+ Wendet das Stylesheet auf den XML-String an.
      * @return Das transformierte XML-Dokument
      */
    public String           apply_xml           ( String xml )                      { return (String)com_call( "apply_xml", xml ); }    
}
