/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.VFS.Factory;

import org.apache.log4j.Logger;

import com.sos.VFS.Interfaces.ISOSVFSHandler;

/**
* \class VFSFactory 
* 
* \brief VFSFactory - 
* 
* \details
*
* \section VFSFactory.java_intro_sec Introduction
*
* \section VFSFactory.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* \version 21.05.2010
* \see reference
*
* Created on 21.05.2010 12:44:25
 */

/**
 * @author KB
 *
 */
public class VFSFactory {

	private final static String	conClassName	= "VFSFactory";
	private static Logger	logger			= Logger.getLogger(VFSFactory.class);

	/**
	 * 
	 * \brief VFSFactory
	 *
	 * \details
	 *
	 */
	public VFSFactory() {
		//
	}

	public static ISOSVFSHandler getHandler(String pstrWhatSystem) throws Exception {

		// TODO eigener Datentyp SOSVirtualFileHandlerSystemType
		
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getHandler";

		ISOSVFSHandler objC = getHandler(pstrWhatSystem, "com.sos.VFS.SSH.SOSSSH2TriLeadImpl");
		return objC;
	}
	
	@SuppressWarnings("unchecked")
	public static ISOSVFSHandler getHandler(String pstrWhatSystem, String pstrNameOfClass2Load) throws Exception {

		// TODO eigener Datentyp SOSVirtualFileHandlerSystemType
		
		final String conMethodName = conClassName + "::getHandler";

		ISOSVFSHandler objC = null;

		// TODO Type of filesystem as an enumeration
		
		 ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
		 
		if (pstrWhatSystem.equalsIgnoreCase("SSH2")) {
			// TODO ber late binding laden, damit es auch als Option verwendet werden kann
			// com.sos.VFS.SSH.SOSSSH2TriLeadImpl
//			objC = new SOSSSH2TriLeadImpl();
//			logger.debug(conMethodName + " returns instance of " + SOSSSH2TriLeadImpl.class.toString());
			// com.sos.VFS.SSH.SOSSSH2GanymedImpl
//			objC = new SOSSSH2GanymedImpl();
//			logger.debug(conMethodName + " returns instance of " + SOSSSH2GanymedImpl.class.toString());
			
//			Class objA =  classLoader.loadClass("com.sos.VFS.SSH.SOSSSH2GanymedImpl");
			Class objA =  classLoader.loadClass(pstrNameOfClass2Load);
			ISOSVFSHandler objD = (ISOSVFSHandler) objA.newInstance();
			logger.debug(conMethodName + " returns instance of " + objD.toString());
			
			if (objD instanceof ISOSVFSHandler) {
				logger.debug("ISOSVFSHandler is part of class   ...  "  + objA.toString());
				objC = (ISOSVFSHandler) objD;	
			}
			else {
				logger.error("ISOSVFSHandler not part of class");
			}
		}

		if (objC == null) {
			String strMsg = conMethodName +  "undefined Virtual File System requested: " + pstrWhatSystem;
			logger.error(strMsg);
			throw new RuntimeException(strMsg);
		}
		
		return objC;
	}

}  // public class VFSFactory 
