/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.VFS.Interfaces;

import java.io.File;

import com.sos.VFS.DataElements.SOSFileTransferMode;

/**
* \class ISOSVirtualFile 
* 
* \brief ISOSVirtualFile - 
* 
* \details
*
* \section ISOSVirtualFile.java_intro_sec Introduction
*
* \section ISOSVirtualFile.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* \version 21.05.2010
* \see reference
*
* Created on 21.05.2010 11:01:32
 */

/**
 * @author KB
 *
 */
public interface ISOSVirtualFile {

	/**
	 * 
	 * \brief deleteFile
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pstrCommandFile
	 * @throws Exception
	 */
	public void deleteFile(final String strFileName) throws Exception;

	/**
	 * 
	 * \brief putFile
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pfleCommandFile
	 * @throws Exception
	 */
	public void putFile(final File fleFile) throws Exception;

	public void putFile(final String strFileName) throws Exception;

	/**
	 * 
	 * \brief getFile
	 * 
	 * \details
	 *
	 * \return ISOSVirtualFile
	 *
	 * @param pstrFileName
	 * @return
	 * @throws Exception
	 */
	public ISOSVirtualFile getFile(final String pstrFileName) throws Exception;

	/**
	 * 
	 * \brief getFileSize
	 * 
	 * \details
	 *
	 * \return long
	 *
	 * @param pstrFileName
	 * @return
	 * @throws Exception
	 */
	public long getFileSize(final String pstrFileName) throws Exception;

	/**
	 * 
	 * \brief getFilePermissions
	 * 
	 * \details
	 *
	 * \return Integer
	 *
	 * @param pstrFileName
	 * @return
	 * @throws Exception
	 * 
	 * 
	 */
	//TODO create Class 'SOSFilePermissions' for FilePermissions.
	public Integer getFilePermissions(final String pstrFileName) throws Exception;

	public void setFilePermissions(final String strFileName, final Integer pintNewPermission) throws Exception;

	public boolean FileExists(final String pstrFileName) throws Exception;

	public boolean isDirectory(final String pstrFileName) throws Exception;
	
	public ISOSVirtualFile TransferMode (final SOSFileTransferMode pobjFileTransferMode) throws Exception;
	
}
