/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// Einzufgen in tabbed.cxx,          Joacim Zschimmer, 26.11.95

/* Eine Zeile mit Feldnamen und evtl. Feldtypen.
   Jedes Feld ist durch einen Separator, blicherweise '\t', ' ', ';' oder ',',  getrennt.
   Typ und Name werden durch Doppelpunkt getrennt. Wenn der Separator nicht Blank ist,
   knnen Blanks verwendet werden und der Doppelpunkt wegfallen.
   Doppelpunkt ist nicht als Separator mglich.


   Typen: c[n]  (character)  Zeichenkette beliebiger oder der angegebenen Lnge, mit Blanks aufgefllt
          n[n[.m]] (numeric) Festpunktzahl mit n Ziffern, davon m Nachkommstellen
          f ??     (float)   -nicht implementiert-
          b        (bool)    0/1
          d        (date)    Alle Formate von Sos_date_type::input, Empf: ISO  yyyy-mm-dd
*/
/*
static Sos_ptr<Field_type> parse_type( Byte** pp )
{
    const char* p = *pp;

    if( *p == ':' ) {
        p++;
        while( *p == ' ' )  p++;
    }
    switch( *p )
    {
        case 'c':
        {
            size = get_number( &p );
            if( size ) {
                Sos_ptr<Sos_limited_text_type> t = SOS_NEW_PTR( Sos_limited_text_type( size ) );
                field_type = +t;
            } else {
                Sos_ptr<Sos_string_type> t = SOS_NEW_PTR( Sos_string_type );
                field_type = +t;
            }
            break;
        }
        case 'n':
        {
            size = get_number( &p );
            if( *p == '.' ) p++;
            scale = get_number( &p ); break;
            if( scale > size )  throw Xc( "record_type_of_name_list", "scale>size" );
            if( size > BIG_INT_PRECISION ) throw Xc( "record_type_of_name_list", "precision" );
            Sos_ptr<Big_int_type> t = SOS_NEW_PTR( Big_int_type( scale ) );s
            field_type = +t;
        }

      //case 'f':
        case 'b':
        {
            Sos_ptr<Bool_type> t = SOS_NEW_PTR( Bool_type );
            field_type = +t;
            break;
        }
        case 'd':
        {
            //while( *p == ' ' )  +p;
            //Format fr tabulierte Datei lesen. Sos_date kann nicht zwei Formate unterscheiden
            Sos_ptr<Sos_optional_date_type> t = SOS_NEW_PTR( Sos_optional_date_type );
            field_type = +t;
            break;
        }

        default: error;
    }
    while( *p == ' ' )  break;

    *pp = p;
}
*/
//---------------------------------------------------------------------------------Tabbed_field

struct Tabbed_field
{
                                Tabbed_field            () : _offset(0),_length(0) {}

    const char*                 char_ptr                () const { return (const char*)this + _offset; }
    int                        _offset;
    int                        _length;
};

//----------------------------------------------------------------------------Tabbed_field_type

struct Tabbed_field_type : Field_type
{
  //virtual void                clear                   ( Byte* p ) const                       { ((Tabbed_field*)p)->_number = 0; }
    void                        print                   ( const Byte*, ostream*, const Text_format& ) const;
    void                        input                   (       Byte*, istream*, const Text_format& ) const;

  protected:
    uint                       _v_field_size            () const { return sizeof (Tabbed_field); }
    void                       _obj_print               ( ostream* s ) const                    { *s << "Tabbed_field"; }
};

extern Tabbed_field_type tabbed_field_type;

void Tabbed_field_type::print( const Byte* p, ostream* s, const Text_format& format ) const
{
    s->write( p + ((Tabbed_field*)p)->_offset, ((Tabbed_field*)p)->_length );
}

void Tabbed_field_type::input( Byte*, istream*, const Text_format& ) const
{
    throw Xc( "Tabbed_field_type::input" );
}

//---------------------------------------------------------------------------------------------

Sos_ptr<Record_type> record_type_of_name_list( const char* name_list, char separator )
{
    Sos_ptr<Dyn_record_type> t = SOS_NEW_PTR( Dyn_record_type );

    const char* p = name_list;

    while(1) {
        Sos_limited_text<max_name_length> name;
        Sos_ptr<Field_type>               field_type;

        while( *p  &&  *p != separator && *p != ' ' )  name += *p++;
        while( *p == ' ' )  p++;
        /*if( *p != separator ) { // Typ
            field_type = parse_type( &p );
        } else*/ {
            Sos_ptr<Sos_string_type> t = SOS_NEW_PTR( Tabbed_field_type );
            field_type = +t;
        }
        if( !*p )  break;

        field_type->add_to( t );
        field_type->add_null_flag_to( t );
    }
}


