/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: sos_perl.cxx 3546 2005-04-03 08:30:29Z jz $     Joacim Zschimmer


#include "precomp.h"
#include "sos.h"
#include "sos_perl.h"


/*
    Fr mehrere Instanzen muss Perl mit -DMULTIPLICITY kompiliert sein.
*/


#if defined SYSTEM_UNIX

namespace sos {






//--------------------------------------------------------------------------------------Perl::~Perl

void Perl::~Perl()
{
    perl_destruct( _perl );
    perl_free( _perl );
}

//---------------------------------------------------------------------------------------Perl::init

void Perl::init()
{
}

//---------------------------------------------------------------------------------------Perl::load

void Perl::load( const string& script_text )
{
    char* args[] = { "", "-e", "(source)" };
    args[2] = script_text.c_str();

    perl_parse( _perl, NULL, sizeof args, args, (char**)NULL);
    perl_run( _perl );
}

//---------------------------------------------------------------------------------------Perl::call

Variant Perl::call( const string& name )
{
    char *args[] = { NULL };

    perl_call_argv( name.c_str(), G_DISCARD | G_NOARGS, args );


              perl_eval_pv("$a = 3; $a **= 2", TRUE);
              printf("a = %d\n", SvIV(perl_get_sv("a", FALSE)));

}

//---------------------------------------------------------------------------------------Perl::call

int Perl::call( const string& name, const vector<int> params )
{
    dSP;                            // initialize stack pointer      
    ENTER;                          // everything created after here 
    SAVETMPS;                       // ...is a temporary variable.   
    PUSHMARK(SP);                   // remember the stack pointer    

    for( int i = 0; i < params.size(); i++ )
    {
        XPUSHs( sv_2mortal( newSViv( params[i] ) ) );
    }

    PUTBACK;                        // make local stack pointer global 

    perl_call_pv( name.c_str(), G_EVAL | G_KEEPERR | G_SCALAR )   // call the function             
    // $@ prfen!

    SPAGAIN;                        // refresh stack pointer         
                                    // pop the return value from stack 
    int result = POPi;

    PUTBACK;
    FREETMPS;                       // free that return value        
    LEAVE;                          // ...and the XPUSHed "mortal" args.

    return result;
}


} //namespace sos

#endif





