/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "sosmain"
//#define COPYRIGHT   "1997 SOS GmbH Berlin"
//#define AUTHOR      "Joacim Zschimmer"

/* Applikation, die main() ruft.
   Ohne Fenster.

   Nicht in einer Bibliothek halten. Explizit einbinden!
*/

#include "sysdep.h"
#include "sysxcept.h"
#include "sosstrng.h"
#include "sos.h"
#include "sosappl.h"    // Sos_static
#include "sosprog.h"    // MFC
#include "log.h"
#include "sosctype.h" //test

#ifdef SYSTEM_WIN
#   include <windows.h>
#   define _CRTDBG_MAPALLOC
#   include <crtdbg.h>
#endif

namespace sos {

extern Bool sos_gui;


#ifdef SYSTEM_WIN
    HINSTANCE _hinstance = 0; 
#endif

#ifdef Z_LINK_STATIC
    extern const bool _dll = false;
#endif

extern int sos_main0( int argc, char** argv );


#if defined __BORLANDC__


    struct Sos_standard_application : Sos_application
    {
        virtual void _main( int, char*[] );
    };


    void Sos_standard_application::_main( int argc, char* argv[] )
    {
        sos_gui = true;
        sos_main0( argc, argv );
        //sos_static_ptr()->close();
    }

    Sos_standard_application sos_application;

#else

//---------------------------------------------------------------------------------------------main

    //int    _argc;
    //char** _argv;

    extern "C" int __cdecl main( int argc, char** argv )
    {
        _argc = argc;
        _argv = argv;

        sos_gui = false;

        int rc = sos_main0( argc, argv );

        return rc;
    }

#endif


//--------------------------------------------------------------------Sos_program::InitInstance
#ifdef SYSTEM_MFC

BOOL Sos_program::InitInstance()  
{
	return FALSE;
}

#endif

} //namespace sos
