/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/* sosmswin.h                                       (c) SOS GmbH Berlin
   MS-Windows-Spezialitten
*/

#if defined SYSTEM_WIN && !defined __SOSMSWIN_H
#define __SOSMSWIN_H

//SOS_DECLARE_MSWIN_HANDLE( HINSTANCE );
#include <windows.h>

namespace sos {


struct Mswin
{
    struct Error : Xc
    {
                                Error                   ( const char* s )
                                                        : Xc( Msg_code( "WIN-", s )) {}
    };

    struct Callback_instance
    {
        /* MakeProcInstance() und FreeProcInstance().
           MakeProcInstance() wird erst bei der ersten Verwendung aufgerufen,
           um bei einer statischen Variablen nicht unntig Windows-Ressourcen zu belegen
           oder Fehler beim Programmstart hervorzurufen.
        */
                                Callback_instance       ( FARPROC );
                               ~Callback_instance       ();

                                operator FARPROC        ();

      private:
        FARPROC                _instance;
        FARPROC                _procedure;
    };

    static HINSTANCE            hinstance               ();
};

ostream& operator << ( ostream&, HINSTANCE ); 

//==========================================================================================inlines

inline Mswin::Callback_instance::Callback_instance( FARPROC procedure )
 : _procedure ( procedure ),
   _instance  ( 0 )
{
}


} //namespace sos

#endif

