/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/

template<class TYPE>
void check_new( void* p ) ;


struct Sossql_status_windows
{
    void                        text                    ( const Sos_string& );
    Bool                        cancel_pressed          ()  { return _cancel_pressed; }

  private:
    static Sos_ptr<Record_type> make_type               ( Dynamic_dialog* = 0 );
    void                        cancel                  ()  { _cancel_pressed = true; }

    Fill_zero                  _zero_;
    Dynamic_dialog*            _dialog_ptr;
    Sos_string                 _text;
};

Sos_ptr<Record_type> Sossql_status_window::make_type( Dynamic_dialog* d )
{
BEGIN_RES_FIELDS
    SOSCTRL_ADD_FIELD ( text, 0 );
    SOSCTRL_ADD_METHOD( Sossql_status_window, cancel, 0 );
    SOSCTRL_ADD_FIXED( bild );   // res_dlg_bild
END_RES_FIELDS
}


Sossql_status_window::Sossql_status_window( Window* parent, const Sos_res_id& res_id )
{
    _dialog_ptr = check_new( new Dynamic_dialog( parent, res_id, SFT_MODELESS ) );
    make_type( _dialog_ptr );
    _dialog_ptr->record_ptr( &AREA( *this ) );
}


void Sossql_status_window::text( const Sos_string& )
{
    _text = text;
    _dialog_ptr->object_auto_load();
}



void main()
{
    Sossql_status_window w;

    w.text( "eins" );
