/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sostimer.h                            1996 SOS GmbH Berlin

#ifndef __SOSTIMER_H
#define __SOSTIMER_H

//#include <time.h>
#ifndef __SOSLIST_H
#   include "soslist.h"
#endif

namespace sos
{

//------------------------------------------------------------------------------clock_as_double

double clock_as_double();

//---------------------------------------------------------------------------Sos_timer_callback

typedef int __cdecl Sos_timer_callback( void* );

//------------------------------------------------------------------------------------Sos_timer

struct Sos_timer
{
                                Sos_timer               ();
                                Sos_timer               ( Sos_timer_callback*, void* _callback_data, double time );
                               ~Sos_timer               ();

    Fill_zero                  _zero_;
    Sos_timer_callback*        _callback;
    void*                      _callback_data;
    double                     _alarm_time;
  //double                     _repeat_time;
};

//-------------------------------------------------------------------------------Sos_timer_node

struct Sos_timer_node : Sos_self_deleting
{
                                Sos_timer_node          () {}
                                Sos_timer_node          ( const Sos_timer& timer, Sos_timer_node* tail ) : _timer(timer), _tail(tail) {}

    void                        remove                  ();

    Sos_timer                  _timer;
    Sos_ptr<Sos_timer_node>    _tail;

  private:
                                Sos_timer_node          ( const Sos_timer_node& );   // nicht implementiert
    Sos_timer_node              operator =              ( const Sos_timer_node& );   // nicht implementiert
};

typedef Sos_timer_node* Sos_timer_handle;

//----------------------------------------------------------------------------Sos_timer_manager

struct Sos_timer_manager : Sos_self_deleting
{
                              //Sos_timer_manager       () : _list ( NULL ) {}


    Sos_timer_handle            add_timer               ( Sos_timer_callback*, void* callback_data,
                                                          double time );
    void                        remove_timer            ( Sos_timer_handle );

    double                      wait_time               ();
    void                        check                   ();

    Sos_ptr<Sos_timer_node>    _list;
};


} //namespace sos

#endif

