/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// video.h

/*
   videobor.* sind derzeit Kopien von video.* und mssen noch fr Borland angepat werden.
   Das meiste wird gelscht, Video heit Video_borland etc.
*/

#ifndef __VIDEO_H
#define __VIDEO_H

#include <conio.h>

#include <jzincl.h>


struct Sos_output_store;
struct Sos_input_store;


const int video_line_length = 80;
const int video_line_count  = 25;

struct Video_attr
{
                                Video_attr              ();
                                Video_attr              ( unsigned char attr );
                                operator unsigned char  () const;

    void                        dark                    ( Bool b );
    Bool                        dark                    () const;
    void                        half_light              ( Bool b );
    Bool                        half_light              () const;
    void                        blinking                ( Bool b );
    Bool                        blinking                () const;
    void                        underlined              ( Bool b );
    Bool                        underlined              () const;
    int                         operator==              ( const Video_attr& a ) const;
    int                         operator!=              ( const Video_attr& a ) const;

    unsigned char _attr;
};

struct Video_char
{
                                Video_char              ();
                                Video_char              ( char, Video_attr );

    char                        chr                     () const;
    Video_attr                  attr                    () const;

    char                       _char;
    Video_attr                 _attr;
};


struct Video_pos
{
                                Video_pos               ();
                                Video_pos               ( int offset );
                                Video_pos               ( int column0, int line0 );
                                Video_pos               ( const Video_pos& vp );

    Video_pos                   operator++              ( int );
    int                         offset                  () const;
    int                         column0                 () const;
    int                         line0                   () const;

    void                        object_store            ( Sos_output_store& );
    Video_pos&                  object_load             ( Sos_input_store& );

  private:
    int                        _offset;
};

struct ostream;
ostream& operator << ( ostream&, Video_pos );

struct Video;
// Funktionspointer-Typ fuer e9750_init
typedef Video* (*Video_create_func)();


struct Video                            // Abstrakt
{
    virtual void                set_cursor              ( Video_pos );
    virtual void                write                   ( Video_pos, char, Video_attr )        = 0;
    virtual void                write                   ( Video_pos, char*, int len, Video_attr );
    virtual void                fill                    ( Video_pos, char, int len, Video_attr );
    virtual void                move                    ( int ziel, int quelle, int zeilenanz ) = 0;
    virtual void                scroll_up               ( int oben, int unten, int anzahl );
    virtual void                scroll_down             ( int oben, int unten, int anzahl );
    virtual void                sync                    ();

    static Video_create_func    create_func;
};


#include <video.inl>
#endif
