/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include <precomp.h>
#define MODULE_NAME "videomem"
// videomem.cpp
//                                                      (c) Joacim Zschimmer

#include <sysdep.h>
#if defined SYSTEM_DOS               // Dieses Modul gilt nur fr DOS-BIOS


#include <stdlib.h>
#include <memory.h>
#include <conio.h>

#include <bios.h>    // biosequip

#include <videomem.h>

//-----------------------------------------------------------------------------

Video_char* Video_memory::_video_buffer = 0;


Video_memory::Video_memory( int )
{
    if (!_video_buffer) {
        _video_buffer =
            (Video_char _far*)
            ((_bios_equiplist() & 0x0030) == 0x0030 ? 0xB0000000     // s/w
                                                    : 0xB8000000);   // Farbe
    }
}

//---------------------------------------------------------Video_memory::write

void Video_memory::write( Video_pos pos, char *text, int len, Video_attr attr )
{
    for (int i = 0; i < len; i++) {
        _video_buffer[ pos.offset() + i ] = Video_char( text[ i ], attr );
    }
}

//----------------------------------------------------------Video_memory::fill

void Video_memory::fill( Video_pos pos, char c, int len, Video_attr attr )
{
    for (int i = 0; i < len; i++) {
        _video_buffer[ pos.offset() + i ] = Video_char( c, attr );
    }
}


#endif                  // SYSTEM_DOS
