/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: xml_sax.h 3546 2005-04-03 08:30:29Z jz $   

#ifndef __SOS_XML_SAX_H
#define __SOS_XML_SAX_H

#ifdef SYSTEM_WIN
//#   import <msxml3.dll> raw_interfaces_only 
//    typedef MSXML2::ISAXAttributes Xml_sax_attributes;
    namespace MSXML2 
    {
        struct ISAXAttributes;
        struct ISAXXMLReader;
    }

    typedef MSXML2::ISAXAttributes Xml_sax_attributes;
    typedef MSXML2::ISAXXMLReader  Xml_sax_reader;

#endif

namespace sos {
namespace xml {
namespace sax {

#ifdef SYSTEM_WIN
    struct Content_handler_for_com;
#endif

//----------------------------------------------------------------------------------------Attributes

struct Attributes
{
                                Attributes              ( Xml_sax_attributes* a )         : _delegated(a) {}

    int                         length                  ();
    string                      local_name              ( int );
    string                      value                   ( int );

    Xml_sax_attributes*        _delegated;
};

//-----------------------------------------------------------------------------------Content_handler

struct Content_handler : Sos_self_deleting
{
    virtual                    ~Content_handler         () {}

    virtual void                start_element           ( const string& namespace_uri, const string& local_name, const string& name, const Attributes& ) = 0;
    virtual void                end_element             ( const string& namespace_uri, const string& local_name, const string& name ) = 0;
    virtual void                start_document          () = 0;
};

//--------------------------------------------------------------------------------------------Reader

struct Reader
{
                                Reader                  ();
    virtual                    ~Reader                  ();

    void                        set_content_handler     ( Content_handler* );
    void                        parse                   ( const string& document );

    Xml_sax_reader*            _delegated;
    Content_handler_for_com*   _content_handler_for_com;
    Sos_ptr<Content_handler>   _content_handler;
};


} //namespace sax
} //namespace xml
} //namespace sos

#endif
