/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: spooler_common.h 6078 2010-04-06 09:53:57Z ss $

#ifndef __SPOOLER_COMMON_H
#define __SPOOLER_COMMON_H


#include "../zschimmer/embedded_files.h"


namespace sos {
namespace scheduler {

#ifdef SYSTEM_WIN
#   define DIR_SEP "\\"
# else
#   define DIR_SEP "/"
#endif


typedef zschimmer::Thread::Id   Thread_id;                  // _beginthreadex()
//typedef DWORD                   Process_id;

namespace time
{
    struct Time;
};

//-------------------------------------------------------------------------------------------------

extern const Embedded_files			embedded_files;             // spooler_embedded_files.cxx

//-----------------------------------------------------------------------------------------FOR_EACH

#define        FOR_EACH(             TYPE, CONTAINER, ITERATOR )  for( TYPE::iterator       ITERATOR = (CONTAINER).begin(); (ITERATOR) != (CONTAINER).end(); (ITERATOR)++ )
#define        FOR_EACH_CONST(       TYPE, CONTAINER, ITERATOR )  for( TYPE::const_iterator ITERATOR = (CONTAINER).begin(); (ITERATOR) != (CONTAINER).end(); (ITERATOR)++ )

//-------------------------------------------------------------------------------------------Do_log

enum Do_log
{
    dont_log = false,
    do_log   = true
};

//-----------------------------------------------------------------------------------First_and_last

enum First_and_last
{
    fl_first_only,
    fl_all,
    fl_last_only,
    fl_first_and_last_only
};

//---------------------------------------------------------------------------------------Visibility

enum Visibility
{
    visible_never = 1,          // Wird nicht automatisch auf visible_yes gesetzt
    visible_no,                 // Kann automatisch auf visible_yes gesetzt werden
    visible_yes
};

//-------------------------------------------------------------------------------------------------

typedef int64                   Process_id;   // Fr Process

//-------------------------------------------------------------------------------------------------

ptr<Com_variable_set>           variable_set_from_environment();
bool                            is_allowed_operation_while_waiting( Async_operation* op );

//-------------------------------------------------------------------------------scheduler_object<>
/*
template< class BASE_CLASS >
struct scheduler_object : BASE_CLASS, Scheduler_object_base
{
                                scheduler_object            ( Spooler* sp, Type_code code )         : Scheduler_object_base( sp, code ) {}
};

//---------------------------------------------------------------------------------Scheduler_object

typedef scheduler_object< Object >  Scheduler_object;       // Standard-Fall
*/
//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos

#endif
