/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#ifndef __SCRIPT_MODULE_SCRIPT_H
#define __SCRIPT_MODULE_SCRIPT_H

#include "../javaproxy/sos__services__scheduler__scripting__Module.h"
#include "../zschimmer/java_com.h"

namespace sos {
namespace scheduler {

//----------------------------------------------------------------------------------Script_module

struct Script_module : Module
{
                                Script_module             ( Spooler*, Prefix_log* = NULL );
    virtual ptr<Module_instance> create_instance_impl       () = 0;

};

//-------------------------------------------------------------------------Script_module_instance

struct Script_module_instance : Module_instance
{
                                Script_module_instance    ( Module* );

    bool                        load                        ()                                      { _loaded = true; return Module_instance::load(); }
  //void                        start                       ();
    virtual void                add_obj                     ( IDispatch*, const string& name );
  //void                        close__end                  ();
    Variant                     call                        ( const string& name );
    Variant                     call                        ( const string& name, const Variant& param, const Variant& );      
    bool                        name_exists                 ( const string& name );
    bool                        loaded                      ()                                      { return _loaded; }
    bool                        callable                    ()                                      { return true; }

    virtual bool                spooler_process             ()                                      { return false; }

    Fill_zero                  _zero_;
    Task*                      _task;
    Has_log*                   _log;
    bool                       _loaded;

    javaproxy::sos::services::scheduler::scripting::Module _java_module;

    typedef list< ptr<z::javabridge::Java_idispatch> >  Added_objects;
    Added_objects              _added_jobjects;

};
//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos

#endif
