/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: olechar.h 4200 2006-03-20 14:49:29Z jz $

#ifndef __ZSCHIMMER_OLECHAR
#define __ZSCHIMMER_OLECHAR

#ifndef Z_WINDOWS

#include <string.h>

//------------------------------------------------------------------------------------------OLECHAR

// #if __STDC_ISO_10646__ >= yyyymm

#ifdef Z_OLECHAR_IS_WCHAR
  //typedef wchar_t             OLECHAR;
#else
    typedef unsigned short      OLECHAR;
#   define Z_OLECHAR_IS_UINT16
#endif

typedef OLECHAR*                LPOLESTR;
typedef const OLECHAR*          LPCOLESTR;

//------------------------------------------------------------------------------------------wmemchr

inline void                     wmemcpy                 ( OLECHAR* d, const OLECHAR* s, int l )      { memcpy( d, s, l * sizeof(OLECHAR) ); }
const OLECHAR*                  wmemchr                 ( const OLECHAR* s, OLECHAR c, int len );
const OLECHAR*                  wcschr                  ( const OLECHAR* s, OLECHAR c );
int                             wcslen                  ( const OLECHAR* s );
int                             wcscmp                  ( const OLECHAR* a, const OLECHAR* b );
int                             wcscasecmp              ( const OLECHAR* a, const OLECHAR* b );
int                             wcsncmp                 ( const OLECHAR* a, const OLECHAR* b, int length );
int                             wcsncmp                 ( const OLECHAR* a, const wchar_t* b, int length );


#ifndef Z_OLECHAR_IS_WCHAR//  sizeof(OLECHAR) != sizeof(wchar_t) ?
    int                         wcscmp                  ( const OLECHAR* a, const wchar_t* b );
    inline int                  wcscmp                  ( const wchar_t* a, const OLECHAR* b )      { return -wcscmp(b,a); }
#endif

#endif

#endif
